// Arous
#include "StdAfx.h"
#include <Mmsystem.h>
#include "arrous.h"
//#define _BE500
#ifdef _BE500
#include <Buzzer.h>
#endif

#define FILENAME_DAT	TEXT("arrous.dat")

unsigned int		wTmCount;			// Time Counter
unsigned int		wArwCount;			// Arrow Counter
unsigned int		wMsgCount;			// Message Counter
unsigned int		wTmWait;			// Wait Time
int					iArwX, iArwY;		// Arrow Position 0`6, 0`12
BYTE				byFrame[7][13];		// Virtual screen
BYTE				byPoint[7][13];		// line check
BYTE				byArrow[2][3];		// Arrow 0=Now, 1=Next
int					iScore;				// Score
int					iHiSc;				// Hight Score
int					iScCount;			// Score Count
//LPVOID				lpWav1;				// wave pon
//LPVOID				lpWav2;				// wave papepin
//LPVOID				lpWav3;				// wave papupepiponpan

int iBtn;
int iBtnNo;
int iBtnFlg;

struct position1_t {
	int	iX;								// 
	int	iY;								// 
};
struct position1_t stBtnOff[] = {
	{ 128,   0 },	// 0 [X]
	{ 128,  16 },	// 1 [SPK]
	{  32,  96 },	// 2 [PAUSE]
	{  32,  64 },	// 3 [ROTATION]
	{  51,  64 },	// 4 []
	{  70,  64 },	// 5 []
	{  89,  64 },	// 6 []
	{ 128,  64 },	// 7 [OPT]
	{ 128, 128 },	// 8 [EAR]
	{ 0,0 }
};
struct position1_t stBtnOn[] = {
	{ 112,  0 },	// 0 [X]
	{ 112, 16 },	// 1 [SPK]
	{  80, 96 },	// 2 [PAUSE]
	{  32, 80 },	// 3 [ROTATION]
	{  51, 80 },	// 4 []
	{  70, 80 },	// 5 []
	{  89, 80 },	// 6 []
	{ 112,  64 },	// 7 [OPT]
	{ 128, 112 },	// 8 [EAR]
	{ 0,0 }
};

struct position2_t {
	WORD wNo;
	int	iX;								// 
	int	iY;								// 
	int	iW;								// 
	int	iH;								// 
	int iSw;							// ON/OFF
};
struct position2_t stBtn[] = {
	{ VK_ESCAPE, 225,   0, 16, 16, OFF },	// 0 [X]
	{ _T('S'),   213,   0, 16, 16, OFF },	// 1 [SPK]
	{ VK_SPACE,   16, 180, 48, 16, OFF },	// 2 [PAUSE]
	{ VK_RETURN,  30, 166, 20, 17, OFF },	// 3 [ROTATION]
	{ VK_DOWN,	  30, 184, 20, 17, OFF },	// 4 []
	{ VK_LEFT,	  10, 184, 20, 17, OFF },	// 5 []
	{ VK_RIGHT,	  50, 184, 20, 17, OFF },	// 6 []
	{ _T('O'),   184,   0, 16, 16, OFF },	// 7 [SPK]
	{ _T('E'),   200,   0, 16, 16, OFF },	// 8 [EAR]
	{ 0,0,0,0,0 }
};

extern HWND		hWndMain;				// CEChẼnh
extern HDC		hdcScreen;				// EChEXN[
extern HDC		hdcNum;					// LN^
//extern HBITMAP	hBmpScreen;				// XN[prbg}bv
extern HDC		hdcBack;				// LN^̔wiۑpnh
extern WORD		wTapX;					// ^bvXW
extern WORD		wTapY;					// ^bvYW
extern WORD		wInKey;					// L[
extern WORD		wInKeyChg;				// ωL[
extern WORD		wInPad;					// L[(J[\ENTER)
extern WORD		wInPadChg;				// ωL[(J[\ENTER)
extern int		nWidth;					// EBhE
extern int		nHeight;				// EChE
extern int		nMainX;					// C\JnYW
extern int		nMainY;					// C\IYW
extern int		nMainW;					// C\
extern int		nMainH;					// C\
extern int		nSubX;					// KCh\JnXW
extern int		nSubY;					// KCh\JnYW
extern int		nSubW;					// KCh\
extern int		nSubH;					// KCh\
extern int		nBlock;					// ubÑTCY
extern POINT	posBlock;				// ubNLN^
extern struct option_t stOption;		// IvV
extern int		iCmnd;					// R}h

// f[^Ǐo
void GmLoadData(void)
{
	int iWork[9];
	HANDLE hFile;
	DWORD nCnt;					// ǂݏof[^

	// datt@CI[v
	hFile = CreateFile(FILENAME_DAT, GENERIC_READ | GENERIC_WRITE,
						FILE_SHARE_READ, NULL, OPEN_EXISTING, 
						FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
//		MessageBox(hWndMain, TEXT("dat I[vł܂."), TEXT("debug"), MB_OK);
		stBtn[1].iSw = ON;		// Speeker ON/OFF
		iHiSc = 0;				// Hight Score
		stOption.iUp    = 0;
		stOption.iLeft  = 0;
		stOption.iDown  = 1;
		stOption.iRight = 0;
		stBtn[8].iSw = ON;		// Speeker ON/OFF
		return;
	}

	ReadFile(hFile, iWork, 9*sizeof(int), &nCnt, NULL);

	if ((iWork[0] == _T('A')) && (iWork[1] == _T('R'))) {
		stBtn[1].iSw    = iWork[2];
		iHiSc           = iWork[3];
		stOption.iUp    = iWork[4];
		stOption.iLeft  = iWork[5];
		stOption.iDown  = iWork[6];
		stOption.iRight = iWork[7];
		stBtn[8].iSw    = iWork[8];
	}

	CloseHandle(hFile);
}

// f[^ۑ
void GmSaveData(void)
{
	int iWork[9];
	HANDLE hFile;
	DWORD wtlen;

	// datt@C쐬
	hFile = CreateFile( FILENAME_DAT, 
						GENERIC_READ | GENERIC_WRITE,
						FILE_SHARE_READ, NULL, CREATE_ALWAYS, 
						FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
//		MessageBox(hWndMain, TEXT("dat 쐬ł܂."), TEXT("debug"), MB_OK);
		return;
	}

	iWork[0] = _T('A');
	iWork[1] = _T('R');
	iWork[2] = stBtn[1].iSw;
	iWork[3] = iHiSc;
	iWork[4] = stOption.iUp;
	iWork[5] = stOption.iLeft;
	iWork[6] = stOption.iDown;
	iWork[7] = stOption.iRight;
	iWork[8] = stBtn[8].iSw;

	WriteFile(hFile, iWork, 9*sizeof(int), &wtlen, NULL);

	CloseHandle(hFile);
}

// 
void GmInitialize(void)
{
	wTmCount = 0;			// Time Counter

	stBtn[0].iX = nMainX+nMainW -  16;		// 0 [X]
	stBtn[1].iX = nMainX+nMainW -  48;		// 1 [SPK]
	stBtn[2].iX = nSubX + 8; //nMainX + 126;		// 2 [PAUSE]
	stBtn[2].iY = nSubY;
	stBtn[3].iX = nSubX + 22; //nMainX + 140;		// 3 [ROTATION]
	stBtn[3].iY = stBtn[2].iY + 18;
	stBtn[4].iX = stBtn[3].iX;			// 4 []
	stBtn[4].iY = stBtn[3].iY + 16;
	stBtn[5].iX = stBtn[4].iX - 20;		// 5 []
	stBtn[5].iY = stBtn[4].iY;
	stBtn[6].iX = stBtn[4].iX + 20;		// 6 []
	stBtn[6].iY = stBtn[4].iY;
	stBtn[7].iX = nMainX+nMainW - 32;		// 7 [OPT]
	stBtn[8].iX = nMainX+nMainW - 64;		// 8 [EAR]

#ifndef _BE500							// BE500ȊOł
	stBtn[8].wNo = 0;					// [EAR]{^Ȃ
#endif

	GmLoadData();
}

// Iݒ
void GmEnd(void)
{
	GmSaveData();
}

// Q[TEh
void GmPlay(int no)
{
	extern HINSTANCE			hInst;			// ݂̃CX^X

	if (stBtn[1].iSw == ON) {
#ifdef _BE500
		switch (no) {
		case 0:										// 0
			StopBuzz(SND_DEV_BUZZER);
			break;
		case 1:										// ړI
			PlayBuzz(TEXT("\\windows\\asterisk.buz"),
					NULL,
					SND_TYP_APPLICATION,
					SND_DEV_BUZZER,
					SND_ASYNC);
			break;
		case 2:										// 
			PlayBuzz(TEXT("\\windows\\exclam.buz"),
					NULL,
					SND_TYP_APPLICATION,
					SND_DEV_BUZZER,
					SND_ASYNC);
			break;
		case 3:										// Q[I[o[
			PlayBuzz(TEXT("\\windows\\question.buz"),
					NULL,
					SND_TYP_APPLICATION,
					SND_DEV_BUZZER,
					SND_ASYNC);
			break;
		}

	}
	if (stBtn[8].iSw == ON) {
#endif
		switch (no) {
		case 0:										// 0
			PlaySound(NULL, hInst, SND_RESOURCE);
			break;
		case 1:										// ړI
			PlaySound(_T("WAVE3"), hInst, SND_RESOURCE | SND_SYNC | SND_NOSTOP);
			break;
		case 2:										// 
			PlaySound(_T("WAVE1"), hInst, SND_RESOURCE | SND_SYNC | SND_NOSTOP);
			break;
		case 3:										// Q[I[o[
			PlaySound(_T("WAVE2"), hInst, SND_RESOURCE | SND_SYNC | SND_NOSTOP);
			break;
		}
	}
}

// Zbg
static void GmReset(void)
{
	iBtn = OFF;
	iBtnFlg = OFF;

	iScore = 0;							// Score
	wTmWait = 20;						// Wait Time
	wArwCount = 0;						// Arrow Count
	wMsgCount = 0;						// Message Count

	srand(wTmCount);
}

// o
static void GmMakeArrows(void)
{
	int y;

	for (y=0; y<2; y++) {
		byArrow[0][y] = byArrow[1][y];
		byArrow[1][y] = (BYTE)(Random() % 4 + 1);	// 1`4
	}

	wTmCount = 0;						// Time Counter

	wArwCount++;
	if (wArwCount >= 10) {
		wArwCount = 0;
		wTmWait--;						// Wait Time
		if (wTmWait == 0) {
			wTmWait = 10;				// Wait Time
		}
	}
}

// X^[g
static void GmStart(void)
{
	int x, y;

	for (y=0; y<13; y++) {
		for (x=0; x<7; x++) {
			byFrame[x][y] = 0;			// Ȃ
		}
	}

	iArwX = 3;							// Arrow Position 0`6
	iArwY = 0;							// Arrow Position 0`12
	GmMakeArrows();
	GmMakeArrows();
	wArwCount = 0;
}

// vbV{^
static void GmPushBtn(int no, int sw)
{
	if (sw) {									// ON
		BitBlt( hdcScreen, 
				stBtn[no].iX, stBtn[no].iY, 
				stBtn[no].iW, stBtn[no].iH, 
				hdcNum, 
				stBtnOn[no].iX, stBtnOn[no].iY, 
				SRCCOPY);
	} else {									// OFF
		BitBlt( hdcScreen, 
				stBtn[no].iX, stBtn[no].iY, 
				stBtn[no].iW, stBtn[no].iH, 
				hdcNum, 
				stBtnOff[no].iX, stBtnOff[no].iY, 
				SRCCOPY);
	}
}

// bN{^
static void GmRockBtn(int no, int sw)
{
	if (sw) {								// ON ̎]
		if (stBtn[no].iSw) {
			stBtn[no].iSw = OFF;
		} else {
			stBtn[no].iSw = ON;
		}
	}

	GmPushBtn(no, stBtn[no].iSw);
}

// {^ON/OFF
static void GmBtn(int no, int sw)
{
	switch (no) {
	case 1:							// Xs[J[
	case 2:							// |[Y
	case 8:							// wbhz
		GmRockBtn(no, sw);
		break;
	default:
		GmPushBtn(no, sw);
		break;
	}
}

// {^
static void GmBtnOn(int no)
{
	GmBtn(no, ON);
	iBtn = ON;
	iBtnNo = no;
}

// {^E^bv
// return : L[R[h
WORD GmCheckBtn(void)
{
	int no;
	int x, y;

	x = wTapX;
	y = wTapY;
	for (no=0; stBtn[no].wNo; no++) {
		if ((stBtn[no].iX < x) && (x < stBtn[no].iX+stBtn[no].iW) &&
			(stBtn[no].iY < y) && (y < stBtn[no].iY+stBtn[no].iH)) {
				
			wInKey = stBtn[no].wNo;
			return stBtn[no].wNo;
		}
	}
	return 0;
}

// Q[bZ[W
void  GmMsgOut(TCHAR *msg)
{
	RECT rt;
	int x, y;

//	x = nMainX + 120;
	x = nSubX;
	y = nMainY + 77;
	PatBlt(hdcScreen, x, y, 64, 16, WHITENESS);

	rt.left   = x;
	rt.right  = rt.left + 64;
	rt.top    = y;
	rt.bottom = rt.top + 16;
	DrawText(hdcScreen, msg, _tcslen(msg), &rt, DT_VCENTER | DT_CENTER);
}

// SCORE
void GmScore(void)
{
	int num;
	int i;
	int pw;
	int scr;
	int x, y;

//	x = nSubX + 120;
	x = nSubX;
	y = nMainY +  97;
	BitBlt(hdcScreen, x, y, 64, 29, hdcNum, 0, 35, SRCCOPY);

	pw = 10000000L;
	scr = iScore;
	num = scr / pw;
	scr -= num * pw;
	pw /= 10;
	for (i=6; i>=0; i--) {
		num = scr / pw;
		scr -= num * pw;
		pw /= 10;
		BitBlt(hdcScreen, x+52-i*8, y+15, 8, 12, 
				hdcNum, num*8, 0, SRCAND);
	}
}

// Hi-SCORE
void GmHiSc(void)
{
	int num;
	int i;
	int pw;
	int scr;
	int x, y;

//	x = nMainX + 120;
	x = nSubX;
	y = nMainY + 128;
	BitBlt(hdcScreen, x, y, 64, 29, hdcNum, 64, 35, SRCCOPY);

	if (iHiSc < iScore) {
		iHiSc = iScore;
	}

	pw = 10000000L;
	scr = iHiSc;
	num = scr / pw;
	scr -= num * pw;
	pw /= 10;
	for (i=6; i>=0; i--) {
		num = scr / pw;
		scr -= num * pw;
		pw /= 10;
		BitBlt(hdcScreen, x+52-i*8, y+15, 8, 12, 
				hdcNum, num*8, 0, SRCAND);
	}
}

// \^
static void GmDispArrow(int sw)
{
	if (sw) {
//		BitBlt(hdcScreen, iArwX*16+nMainX+4,  iArwY*16+nMainY+4, 16, 16, 
//				hdcNum, (byArrow[0][0]-1)*16, 16, SRCCOPY);
//		BitBlt(hdcScreen, iArwX*16+nMainX+4, (iArwY+1)*16+nMainY+4, 16, 16, 
//				hdcNum, (byArrow[0][1]-1)*16, 16, SRCCOPY);
		BitBlt(hdcScreen, iArwX*nBlock+nMainX+4,  iArwY*nBlock+nMainY+4, nBlock, nBlock, 
				hdcNum, (byArrow[0][0]-1)*nBlock+posBlock.x, posBlock.y, SRCCOPY);
		BitBlt(hdcScreen, iArwX*nBlock+nMainX+4, (iArwY+1)*nBlock+nMainY+4, nBlock, nBlock, 
				hdcNum, (byArrow[0][1]-1)*nBlock+posBlock.x, posBlock.y, SRCCOPY);
	} else {
//		BitBlt(hdcScreen, iArwX*16+nMainX+4,  iArwY*16+nMainY+4, 16, 16*2, 
//				hdcBack, iArwX*16+4, iArwY*16+4, SRCCOPY);
		BitBlt(hdcScreen, iArwX*nBlock+nMainX+4,  iArwY*nBlock+nMainY+4, nBlock, nBlock*2, 
				hdcBack, iArwX*nBlock+4, iArwY*nBlock+4, SRCCOPY);
	}
}

// ҋ@\
static void GmDispNext(void)
{
	BitBlt(hdcScreen, nSubX+24,    nMainY+18+20, 16, 16, 
			hdcNum, (byArrow[1][0]-1)*16, 16, SRCCOPY);
	BitBlt(hdcScreen, nSubX+24, 16+nMainY+18+20, 16, 16, 
			hdcNum, (byArrow[1][1]-1)*16, 16, SRCCOPY);
}

// {ʍ쐬
void GmMakeMain(void)
{
	int i;

	// wi
	BitBlt(hdcScreen, nMainX, nMainY, nMainW+nSubW, nMainH+nSubH, 
			hdcBack, 0, 0, SRCCOPY);

	BitBlt(hdcScreen, nSubX+16, nMainY+4+20, 32, 48, hdcNum, 0, 64, SRCCOPY);	// NEXT

	// START
	GmStart();
	for (i=0; stBtn[i].wNo; i++) {
		GmBtn(i, OFF);
	}
	GmMsgOut(_T(""));
	GmScore();
	GmHiSc();
}

// dȂ蔻
static int GmCheckOverlap(int x, int y)
{
	if ((x < 0) || (x >= 7)) {
		return -1;
	} else if (y > 11) {
		return -1;
	} else if (byFrame[x][y]) {
		return -1;
	} else if (byFrame[x][y+1]) {
		return -1;
	} else {
		return 0;
	}
}

// є
static void GmCheckLine(void)
{
	int x, y;
	BYTE base;

	for (y=0; y<13; y++) {
		for (x=0; x<7; x++) {
			base = byFrame[x][y];
			if (base == 0) {
				continue;
			}
			if (x < 4) {
				// R
				if ((base == byFrame[x+1][y]) &&
					(base == byFrame[x+2][y]) &&
					(base == byFrame[x+3][y])) {
					byPoint[x][y]++;
					byPoint[x+1][y]++;
					byPoint[x+2][y]++;
					byPoint[x+3][y]++;
				}
			}
			if (y < 10) {
				// ^e
				if ((base == byFrame[x][y+1]) &&
					(base == byFrame[x][y+2]) &&
					(base == byFrame[x][y+3])) {
					byPoint[x][y]++;
					byPoint[x][y+1]++;
					byPoint[x][y+2]++;
					byPoint[x][y+3]++;
				}
			}
			if ((x < 4) && (y < 10)) {
				// E΂߉
				if ((base == byFrame[x+1][y+1]) &&
					(base == byFrame[x+2][y+2]) &&
					(base == byFrame[x+3][y+3])) {
					byPoint[x][y]++;
					byPoint[x+1][y+1]++;
					byPoint[x+2][y+2]++;
					byPoint[x+3][y+3]++;
				}
			}
			if ((x > 2) && (y < 10)) {
				// ΂߉
				if ((base == byFrame[x-1][y+1]) &&
					(base == byFrame[x-2][y+2]) &&
					(base == byFrame[x-3][y+3])) {
					byPoint[x][y]++;
					byPoint[x-1][y+1]++;
					byPoint[x-2][y+2]++;
					byPoint[x-3][y+3]++;
				}
			}
		}
	}
}

// E_vZ
static void GmCheckPoint(void)
{
	int x, y;

	for (y=0; y<13; y++) {
		for (x=0; x<7; x++) {
			if (byPoint[x][y]) {
				iScCount += byPoint[x][y];
				byPoint[x][y] = 0;
				byFrame[x][y] = 0;
//				BitBlt(hdcScreen, x*16+nMainX+4, y*16+nMainY+4, 16, 16, 
//						hdcBack, x*16+4, y*16+4, SRCCOPY);
				BitBlt(hdcScreen, x*nBlock+nMainX+4, y*nBlock+nMainY+4, nBlock, nBlock, 
						hdcBack, x*nBlock+4, y*nBlock+4, SRCCOPY);
			}
		}
	}
}

// 󗎉
static int GmUpperDown(int x, int y)
{
	int yy;
	int pos;

	pos = y;
	for (yy=y-1; yy>=0; yy--) {
		if (byFrame[x][yy] != 0) {	// 󂠂
			byFrame[x][pos] = byFrame[x][yy];
			BitBlt(hdcScreen, x*nBlock+nMainX+4, pos*nBlock+nMainY+4, nBlock, nBlock, 
					hdcNum, (byFrame[x][pos]-1)*nBlock+posBlock.x, posBlock.y, 
					SRCCOPY);	// 
			byFrame[x][yy] = 0;
			BitBlt(hdcScreen, x*nBlock+nMainX+4, yy*nBlock+nMainY+4, nBlock, nBlock, 
					hdcBack, x*nBlock+4, yy*nBlock+4, SRCCOPY);					// obN
			pos--;
		}
	}
	return 0;						// Ȃ
}

// ԋl
static void GmFall(void)
{
	int x, y;

	for (x=0; x<7; x++) {
		for (y=12; y>0; y--) {
			if (byFrame[x][y] == 0) {
				GmUpperDown(x, y);
				break;
			}
		}
	}
}

// Jn
static void GmReadyGo(void)
{
	GmReset();
	GmMakeMain();
	GmDispArrow(ON);
	GmDispNext();
	wInPad = 0;
}

// ^Cg
void  GmSetTitle(void)
{
	RECT rt;
	int x, y;
	TCHAR msg[32];

	x = (nWidth - 128) / 2;
	y = nHeight / 2 - 16;
	BitBlt(hdcScreen, x, y, 128, 32, hdcNum, 0, 144, SRCPAINT);
	BitBlt(hdcScreen, x, y, 128, 32, hdcNum, 0, 112, SRCAND);

	y = nHeight / 4 * 3;
	wcscpy(msg, _T(" Hit a Key to Start "));
	rt.left   = x;
	rt.right  = rt.left + 128;
	rt.top    = y;
	rt.bottom = rt.top + 16;
	DrawText(hdcScreen, msg, _tcslen(msg), &rt, DT_VCENTER | DT_CENTER);

	GmBtn(0, OFF);
	GmBtn(1, OFF);
	GmBtn(7, OFF);
#ifdef _BE500
	GmBtn(8, OFF);
#endif
}

// I[vjO
static int GmState0(int *state)
{
	extern HINSTANCE hInst;			// ݂̃CX^X
	extern HDC		hdcTitle;		// ^Cgpnh
	extern HBITMAP	hBmpTitle;		// ^Cgprbg}bv
//	static unsigned int cnt = 10;
	static int st = 0;
	int no;

//	cnt++;

	switch (st) {
	case 0:									// 
		hdcTitle = CreateCompatibleDC(GetDC(hWndMain));
		hBmpTitle = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BITMAP2));
		SelectObject(hdcTitle, hBmpTitle);
		BitBlt(hdcScreen, nMainX, nMainY, nMainW+nSubW, nMainH+nSubH, hdcTitle, 0, 0, SRCCOPY);
		DeleteDC(hdcTitle);
		DeleteObject(hBmpTitle);
		GmSetTitle();
		wTmCount = 0;
		st++;
		return 0;
	}

	wTmCount++;
	no = 0;

	switch (wInKeyChg) {
	case VK_ESCAPE:
		GmBtnOn(0);
		return -1;
	case VK_RETURN:
	case VK_UP:
		no = 3;
		break;
	case TEXT('S'):					// [S]
	case TEXT('s'):					// [s]
		GmBtnOn(1);
		return 0;
	case TEXT('O'):					// [O]
	case TEXT('o'):					// [o]
		GmBtnOn(7);
		return 0;
#ifdef _BE500
	case TEXT('E'):					// [E]
	case TEXT('e'):					// [e]
		GmBtnOn(8);
		return 0;
#endif
	}

	if ((wInPadChg) || (wInKeyChg)) {
		no = 3;
	}

	if (no) {
		GmReadyGo();
		GmBtnOn(no);
		st = 0;
		(*state)++;
	}
	return 0;
}

// 
static int GmState1(int *state)
{
	static int cnt = 0;
	static int add = 1;
	WORD key[4];

	cnt = (cnt+1) & 0x7FFF;

	if (wMsgCount) {
		wMsgCount--;
		if (wMsgCount == 0) {
			GmMsgOut(_T(""));
		}
	}

	switch (wInKeyChg) {
	case VK_ESCAPE:
		GmBtnOn(0);
		return -1;
	case TEXT('S'):					// [S]
	case TEXT('s'):					// [s]
		GmBtnOn(1);
		break;
	case TEXT('O'):					// [O]
	case TEXT('o'):					// [o]
		GmBtnOn(7);
		break;
#ifdef _BE500
	case TEXT('E'):					// [E]
	case TEXT('e'):					// [e]
		GmBtnOn(8);
		break;
#endif
	case VK_SPACE:
		GmBtnOn(2);
		add = 1 - add;
		break;
	}

	if (stOption.iUp) {
		key[0] = wInPad;
	} else {
		key[0] = wInPadChg;
	}
	if (stOption.iLeft) {
		key[1] = wInPad;
	} else {
		key[1] = wInPadChg;
	}
	if (stOption.iDown) {
		key[2] = wInPad;
	} else {
		key[2] = wInPadChg;
	}
	if (stOption.iRight) {
		key[3] = wInPad;
	} else {
		key[3] = wInPadChg;
	}

	if (key[0] & (BIT_KEY_UP | BIT_KEY_RETURN)) {
		GmBtnOn(3);
		GmDispArrow(OFF);
		byArrow[0][0] = (byArrow[0][0] < 4)? (byArrow[0][0] + 1): 1;
		byArrow[0][1] = (byArrow[0][1] < 4)? (byArrow[0][1] + 1): 1;
		byArrow[0][2] = (byArrow[0][2] < 4)? (byArrow[0][2] + 1): 1;
		GmDispArrow(ON);

	} else if (key[1] & BIT_KEY_LEFT) {				// []
		GmBtnOn(5);
		if (!GmCheckOverlap(iArwX-1, iArwY)) {
			GmDispArrow(OFF);
			iArwX--;
			GmDispArrow(ON);
		}
	} else if (key[3] & BIT_KEY_RIGHT) {			// []
		GmBtnOn(6);
		if (!GmCheckOverlap(iArwX+1, iArwY)) {
			GmDispArrow(OFF);
			iArwX++;
			GmDispArrow(ON);
		}
	} else if (key[2] & BIT_KEY_DOWN) {				// []
		GmBtnOn(4);
		wTmCount = wTmWait;
	}

	wTmCount += add;
	if (wTmCount > wTmWait) {
		wTmCount = 0;
		if (GmCheckOverlap(iArwX, iArwY+1)) {
			(*state)++;
		} else {
			GmDispArrow(OFF);
			iArwY++;
			GmDispArrow(ON);
		}
	}

	return 0;
}

// 莞̏
static int GmState2(int *state)
{
	static int st = 0;
	static int chain;
	static int tim;
	static int add;
	int x, y;
	TCHAR msg[16];

	switch (st) {
	case 0:									// 
		GmPlay(1);
		byFrame[iArwX][iArwY]   = byArrow[0][0];
		byFrame[iArwX][iArwY+1] = byArrow[0][1];
		for (y=0; y<13; y++) {
			for (x=0; x<7; x++) {
				byPoint[x][y] = 0;			// Ȃ
			}
		}
		chain = 0;
		add = 0;
		st++;
		break;

	case 1:									// є
		iScCount = 0;
		GmCheckLine();
		GmCheckPoint();
		st++;
		break;

	case 2:									// 
		GmFall();
		st++;
		break;

	case 3:									// 
		if (iScCount) {
			GmPlay(2);
			chain++;
			iScCount *= chain;
			add += iScCount;
			wsprintf(msg, _T("%d pt"), add);
			wMsgCount = 30;
			GmMsgOut(msg);
			iScore += iScCount;
			st++;
		} else {
			st = 10;
		}
		break;

	case 4:										// EFCg
		st++;
		break;
	case 5:										// ̔
		st = 1;
		break;

	case 10:									// I
		st = 0;
		GmScore();
		GmHiSc();
		iArwX = 3;							// Arrow Position 0`6
		iArwY = 0;							// Arrow Position 0`12
		if (byFrame[iArwX][iArwY+1] == 0) {
			GmMakeArrows();
			GmDispArrow(ON);
			GmDispNext();
			(*state) = 1;
		} else {
			(*state)++;
		}
		break;
	}
	return 0;
}

// Q[I[o[
static int GmState3(int *state)
{
	static int st = 0;


	switch (wInKeyChg) {
	case VK_ESCAPE:
		GmBtnOn(0);
		return -1;
	}

	switch (st) {
	case 0:
		GmMsgOut(_T("GameOver"));
		st++;
		break;
	case 3:
		GmPlay(3);
		st++;
		break;
	case 60:
		*state = 0;
		st = 0;
		break;
	default:
		st++;
		break;
	}

	return 0;
}

// Q[C
// 100mSɌĂяo
int GmMain(int *state)
{
	if (iBtn == ON) {
		if (iBtnNo == 7) {
			iCmnd = 7;
		}
		iBtn = OFF;
		GmBtn(iBtnNo, OFF);
	}

	switch (*state) {
	case 0:					// I[vjO
		return GmState0(state);
	case 1:					// 
		return GmState1(state);
		break;
	case 2:					// 莞̏
		return GmState2(state);
		break;
	case 3:					// Q[I[o[
		return GmState3(state);
		break;
	}

	return 0;
}
